/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.ldt.bills.controller;

import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.springblade.common.aop.core.TenantAop;
import org.springblade.common.constant.Salesman;
import org.springblade.common.enums.AppConstant;
import org.springblade.common.enums.CsFlag;
import org.springblade.common.utils.ExcelWriteUtil;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.ldt.bills.entity.Bills;
import org.springblade.ldt.bills.service.IBillsService;
import org.springblade.ldt.bills.vo.BillsVO;
import org.springblade.ldt.bills.wrapper.BillsWrapper;
import org.springblade.ldt.mall.service.IMallService;
import org.springblade.ldt.shop.service.IShopService;
import org.springblade.ldt.user.service.ILoginUserService;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import javax.validation.Valid;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 控制器
 *
 * @author BladeX
 * @since 2021-09-23
 */
@RestController
@AllArgsConstructor
@RequestMapping("ldt_bills/bills")
@Api(value = "", tags = "接口")
@Slf4j
public class BillsController extends BladeController {

	private final IBillsService billsService;

	private final ILoginUserService loginUserService;

	private final IShopService shopService;

	private final IMallService mallService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入bills")
	@TenantAop(salesman = Salesman.roleName)
	public R<BillsVO> detail(Bills bills) {
		return R.data(BillsWrapper.build(loginUserService, shopService, mallService).entityVO(billsService.getOne(Condition.getQueryWrapper(bills))));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入bills")
	@TenantAop(salesman = Salesman.roleName)
	public R<IPage<BillsVO>> list(Bills bills, Query query, Date createTimeStart, Date createTimeEnd, String key) {
		QueryWrapper<Bills> queryWrapper = Condition.getQueryWrapper(bills);
		//添加创建时间条件
		if (createTimeStart != null && createTimeEnd != null) {
			queryWrapper.lambda().between(Bills::getCreateTime, createTimeStart, createTimeEnd);
		}
		//添加关键字key查询条件
		if (StringUtils.isNotBlank(key)) {
			queryWrapper.lambda().and(wq -> {
				wq.eq(Bills::getId, key);
			});
		}
		return R.data(BillsWrapper.build(loginUserService, shopService, mallService).pageVO(billsService.page(Condition.getPage(query), queryWrapper)));
	}

	/**
	 * 生成列表
	 */
	@PostMapping("/generateList")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "生成列表", notes = "传入withdrawRec")
	@TenantAop(salesman = Salesman.roleName)
	public void generateList(Bills bills, Query query, Date createTimeStart, Date createTimeEnd,
							 String key,
							 @RequestParam String keyValue,
							 HttpServletResponse response) {
		try {
			R<IPage<BillsVO>> page = this.list(bills, query, createTimeStart, createTimeEnd, key);
			//判断是否为空
			if (ObjectUtils.isNotEmpty(page) && ObjectUtils.isNotEmpty(page.getData()) && ObjectUtils.isNotEmpty(page.getData().getRecords())) {
				//键值对
				Map<String, String> titleMap = JSONObject.parseObject(keyValue, Map.class);
				if (ObjectUtils.isNotEmpty(titleMap)) {
					//写入到Excel
					ExcelWriteUtil.writeToResponse(response, DateUtil.now(), "提现记录表", titleMap, page.getData().getRecords(), BillsVO.class);
					return;
				}
			}
		} catch (Exception e) {
			log.error(e.getMessage());
		}
	}

	/**
	 * 统计金额
	 */
	@GetMapping("/censusPrice")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "统计金额", notes = "统计金额")
	public R<List<Map<String, Object>>> censusPrice() {
		return R.data(billsService.listMaps(new QueryWrapper<Bills>()
			.select("sum(total_price) as price,type as type")
			.lambda()
			.and(wq -> {
				wq.eq(Bills::getCsFlag, CsFlag.CHECK).or().eq(Bills::getPayStatus, AppConstant.BillPayStatus.付款成功.name());
			})
			.groupBy(Bills::getType)));
	}

	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入bills")
	public R<IPage<BillsVO>> page(BillsVO bills, Query query) {
		IPage<BillsVO> pages = billsService.selectBillsPage(Condition.getPage(query), bills);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入bills")
	public R save(@Valid @RequestBody Bills bills) {
		return R.status(billsService.save(bills));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入bills")
	public R update(@Valid @RequestBody Bills bills) {
		return R.status(billsService.updateById(bills));
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入bills")
	public R submit(@Valid @RequestBody Bills bills) {
		return R.status(billsService.saveOrUpdate(bills));
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(billsService.deleteLogic(Func.toLongList(ids)));
	}


}
